/* O'Caml stubs for SHA1, by Gerd Stolpmann */

#include "sha1.h"
#include "mlvalues.h"
#include "alloc.h"

/* For simplicity, we statically allocate the SHA1_CTX. Thus, this module
   is not thread-safe
*/

SHA1_CTX ctx;

value sha1_init(value dummy) {
    SHA1Init(&ctx);
    return Val_unit;
}


value sha1_update(value s, value n) {
    int m;
    m = caml_string_length(s);
    if (Int_val(n) < m) m = Int_val(n);
    SHA1Update(&ctx, (unsigned char *) String_val(s), m);
    return Val_unit;
}


value sha1_final(value dummy) {
    value r;
    int k;
    unsigned char digest[20];
    SHA1Final(digest, &ctx);
    r = caml_alloc_string(20);
    for (k=0; k<20; k++)
	Byte_u(r,k) = digest[k];
    return r;
}
